# TONIC Distribution Speeds

The "TONIC Speed" is defined by the amount of TONIC emitted per block to suppliers and borrowers. The speed of token distribution is unique to each market and also to supplier and borrowers. Distribution within each market is controlled by our [TectonicCore](/docs/developer/tectoniccore.md) contract via `tonicSupplySpeeds` and `borrowSupplySpeeds`.

<pre class="language-solidity"><code class="lang-solidity">TectonicCore core = TectonicCare(0x123...)
address tToken = 0xabc...
// Amount of TONIC emitted to suppliers on tToken market each block
uint tonicSupplySpeed = tonicSupplySpeeds(tToken)
// Amount of TONIC emitted to borrowers on tToken market each block
<strong>uint tonicBorrowSpeed = tonicBorrowSpeeds(tToken)
</strong></code></pre>


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://tectonic.gitbook.io/docs/developer/tonic-distribution-speeds.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
